searchNodes=[{"ref":"Brook.html","title":"Brook","type":"module","doc":"Brook provides an event stream client interface for distributed applications to communicate indirectly and asynchronously. Brook sends and receives messages with the event stream (typically a message queue service) via a driver module and persists an application-specific view of the event stream via a storage module (defaulting to ETS). Sample Configuration Brook is configured within the application environment by defining a keyword list with three primary keys: driver, handler, and storage. config :my_app, :brook, driver: [ module: Brook.Driver.Json, init_arg: [] ], handler: [MyApp.Event.Handler], storage: [ modules: Brook.Storage.Ets, init_arg: [] ] Driver The Brook driver implements a behaviour that sends messages to the event stream. Events are Brook structs that contain an event type, an author (or source), a creation timestamp, the event data, and an ack reference and ack data (following the lead of the broadway library.) The default driver sends the event message to the Brook server via Genserver.cast Additional drivers provided at this time are a json-encoding version of the default driver and a Kafka driver using the elsa library. Handler The Brook handler implements a behaviour that provides a handle_event/1 function. Handlers receive a Brook event and take appropriate action according to the implementing application&#39;s business logic. Applications implement as many function heads for the event handler as necessary and return one of four tuples depending on how the storage module should treat the event with respect to persistence. Events can: create a record in the view state via the {:create, collection, key, value} return update an existing record via the {:merge, collection, key, value} return delete a record via the {:delete, collection, key} return discard the record and do not effect the persistent view via the :discard return Storage The Brook storage module implements yet another behaviour that persists event data to an application view state specific to the application importing the Brook library, allowing the application to only store information received from the event stream that is relevant to its own domain and retrieve it when necessary. Storage modules implement basic CRUD operations that correlate to the return values of the event handler module. The default module uses ETS for fast, local, in-memory storage and retrieval (great for testing purposes!) with an additional Redis-based module as well."},{"ref":"Brook.html#child_spec/1","title":"Brook.child_spec/1","type":"function","doc":"Provides a Brook Supervisor child spec for defining a custom Brook supervisor."},{"ref":"Brook.html#get/2","title":"Brook.get/2","type":"function","doc":"Return an item from the Brook view state for the implementing application wrapped in an :ok tuple or else an :error tuple with a reason."},{"ref":"Brook.html#get!/2","title":"Brook.get!/2","type":"function","doc":"Returns the value stored under the given key and collection from the Brook view state or else raises an exception."},{"ref":"Brook.html#get_all/1","title":"Brook.get_all/1","type":"function","doc":"Return all values saved to the Brook view state for a given collection, wrapped in an :ok tuple or else an :error tuple with reason. Values are returned as a map where the keys are the keys used to index the saved values and the values are anything saved under a given key based on processing events."},{"ref":"Brook.html#get_all!/1","title":"Brook.get_all!/1","type":"function","doc":"Return all values saved to the Brook view state for a given collection or else raises an exception. Values are returned as a map where the keys are the keys used to index the saved values and the values are anything saved under a given key."},{"ref":"Brook.html#get_all_values/1","title":"Brook.get_all_values/1","type":"function","doc":"Returns a list of all values saved to a given collection of the Brook view state, indepentent of the key used to index them. Results is wrapped in an :ok tuple or else an :error tuple with reason is returned."},{"ref":"Brook.html#get_all_values!/1","title":"Brook.get_all_values!/1","type":"function","doc":"Returns a list of all values saved to a given collection of the Brook view state, independent of the key used to index them, or else raises an exception."},{"ref":"Brook.html#get_events/2","title":"Brook.get_events/2","type":"function","doc":"Returns a list of Brook events that produced the value stored under the given key within a collection from the Brook view state, wrapped in an :ok tuple or else an :error tuple with reason."},{"ref":"Brook.html#get_events!/2","title":"Brook.get_events!/2","type":"function","doc":"Returns a list of Brook events that produced the value stored under the given key within a collection from the Brook view state or else raises an exception."},{"ref":"Brook.html#start_link/1","title":"Brook.start_link/1","type":"function","doc":"Starts a Brook process linked to the current process."},{"ref":"Brook.html#t:author/0","title":"Brook.author/0","type":"type","doc":"The source application generating an event message"},{"ref":"Brook.html#t:event/0","title":"Brook.event/0","type":"type","doc":"The data component of an event message"},{"ref":"Brook.html#t:event_type/0","title":"Brook.event_type/0","type":"type","doc":"The catagory of event to contextualize the data of an event message"},{"ref":"Brook.html#t:reason/0","title":"Brook.reason/0","type":"type","doc":"The potential negative return value of a view state query."},{"ref":"Brook.html#t:view_collection/0","title":"Brook.view_collection/0","type":"type","doc":"The grouping of events by catagory for persisted view storage"},{"ref":"Brook.html#t:view_key/0","title":"Brook.view_key/0","type":"type","doc":"The index by which events are stored in a view state collection"},{"ref":"Brook.html#t:view_value/0","title":"Brook.view_value/0","type":"type","doc":"The event data stored within a view state collection, indexed by key"},{"ref":"Brook.Config.html","title":"Brook.Config","type":"module","doc":"Constructs a new Brook server config struct from a keyword list of inputs."},{"ref":"Brook.Config.html#new/1","title":"Brook.Config.new/1","type":"function","doc":"Take a keyword list and extracts values necessary to configure a Brook server. Provides default values for the driver and dipatcher but fails if event_handler or storage are not supplied by the user."},{"ref":"Brook.Dispatcher.html","title":"Brook.Dispatcher","type":"behaviour","doc":"Defines the Brook Dispatcher behaviour, requiring the init/0 and dispatch/1 functions be implemented by the client."},{"ref":"Brook.Dispatcher.html#c:dispatch/1","title":"Brook.Dispatcher.dispatch/1","type":"callback","doc":"Distributes received messages across multiple nodes."},{"ref":"Brook.Dispatcher.html#c:init/0","title":"Brook.Dispatcher.init/0","type":"callback","doc":"Start a Brook dispatcher."},{"ref":"Brook.Dispatcher.Default.html","title":"Brook.Dispatcher.Default","type":"module","doc":"Default implementation for the Brook.Dispatcher Creates and joins a process group named :brook_servers. Ensures all members of the process group receive notification of the received event by a member of the group."},{"ref":"Brook.Dispatcher.Default.html#dispatch/1","title":"Brook.Dispatcher.Default.dispatch/1","type":"function","doc":"Takes an event struct and forwards the event on to other member nodes of the :brook_servers process group after tagging the forwarded status of the event to true."},{"ref":"Brook.Dispatcher.Default.html#init/0","title":"Brook.Dispatcher.Default.init/0","type":"function","doc":"Creates and joins the Brook server to the process group named :brook_servers."},{"ref":"Brook.Driver.html","title":"Brook.Driver","type":"behaviour","doc":"Defines the behaviour clients must implement in order to send events to the event stream. Ensures a child specification is defined and a process can be started and linked to the calling process, as well as sending serialized events with an accompanying event type for pattern matching to handle different types of events from a single client event handling module."},{"ref":"Brook.Driver.html#c:child_spec/1","title":"Brook.Driver.child_spec/1","type":"callback","doc":"Return a child specification for the Brook driver for inclusion in an application supervision tree."},{"ref":"Brook.Driver.html#c:send_event/2","title":"Brook.Driver.send_event/2","type":"callback","doc":"Send a Brook event to the event stream with a contextual event type and a data value serialized for transfer."},{"ref":"Brook.Driver.html#c:start_link/1","title":"Brook.Driver.start_link/1","type":"callback","doc":"Start a Brook driver and link to the current process."},{"ref":"Brook.Driver.html#t:serialized_event/0","title":"Brook.Driver.serialized_event/0","type":"type","doc":"Brook event message data encoded to a serialized format"},{"ref":"Brook.Driver.Default.html","title":"Brook.Driver.Default","type":"module","doc":"Default implmentation of the Brook.Driver behaviour. Simply casts the event to the Brook server by way of a registry lookup."},{"ref":"Brook.Driver.Default.html#child_spec/1","title":"Brook.Driver.Default.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Driver.Default.html#init/1","title":"Brook.Driver.Default.init/1","type":"function","doc":"Initializes the default Brook driver with an empty state."},{"ref":"Brook.Driver.Default.html#send_event/2","title":"Brook.Driver.Default.send_event/2","type":"function","doc":"Takes event data and casts to the Brook server to process."},{"ref":"Brook.Driver.Default.html#start_link/1","title":"Brook.Driver.Default.start_link/1","type":"function","doc":"Start the default Brooker driver GenServer and link it to the current process."},{"ref":"Brook.Driver.Kafka.html","title":"Brook.Driver.Kafka","type":"module","doc":"Implements the Brook.Driver behaviour for using Kafka as the message bus underlying the event stream. Brook&#39;s Kafka driver uses the (Elsa)[https://github.com/bbalser/elsa] library for subscribing to and sending messages to a Kafka topic handling event stream communication between distributed applications."},{"ref":"Brook.Driver.Kafka.html#child_spec/1","title":"Brook.Driver.Kafka.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Driver.Kafka.html#init/1","title":"Brook.Driver.Kafka.init/1","type":"function","doc":"Initialize the Elsa supervision tree for the consumer of the event stream topic."},{"ref":"Brook.Driver.Kafka.html#send_event/2","title":"Brook.Driver.Kafka.send_event/2","type":"function","doc":"Send Brook event messages to the event stream topic."},{"ref":"Brook.Driver.Kafka.html#start_link/1","title":"Brook.Driver.Kafka.start_link/1","type":"function","doc":"Start Brook.Driver and link to the current process"},{"ref":"Brook.Driver.Kafka.Handler.html","title":"Brook.Driver.Kafka.Handler","type":"module","doc":"Implements the Elsa message handler behaviour for the Brook Kafka driver."},{"ref":"Brook.Driver.Kafka.Handler.html#generation_id/0","title":"Brook.Driver.Kafka.Handler.generation_id/0","type":"function","doc":""},{"ref":"Brook.Driver.Kafka.Handler.html#handle_messages/1","title":"Brook.Driver.Kafka.Handler.handle_messages/1","type":"function","doc":"Takes a list of Kafka messages consumed by Elsa and processes each with Brook."},{"ref":"Brook.Driver.Kafka.Handler.html#handle_messages/2","title":"Brook.Driver.Kafka.Handler.handle_messages/2","type":"function","doc":"Callback implementation for Elsa.Consumer.MessageHandler.handle_messages/2."},{"ref":"Brook.Driver.Kafka.Handler.html#init/1","title":"Brook.Driver.Kafka.Handler.init/1","type":"function","doc":"Callback implementation for Elsa.Consumer.MessageHandler.init/1."},{"ref":"Brook.Driver.Kafka.Handler.html#name/0","title":"Brook.Driver.Kafka.Handler.name/0","type":"function","doc":""},{"ref":"Brook.Driver.Kafka.Handler.html#partition/0","title":"Brook.Driver.Kafka.Handler.partition/0","type":"function","doc":""},{"ref":"Brook.Driver.Kafka.Handler.html#topic/0","title":"Brook.Driver.Kafka.Handler.topic/0","type":"function","doc":""},{"ref":"Brook.Event.html","title":"Brook.Event","type":"module","doc":"The Brook.Event struct is the basic unit of message written to and read from the event stream. It encodes the type of event (for application event handlers to pattern match on), the author (source application), The creation timestamp of the message, the actual data of the message, and a boolean detailing if the message was forwarded within the Brook Server process group. The data component of the message is an arbitrary Elixir term but is typically a map or struct."},{"ref":"Brook.Event.html#process/1","title":"Brook.Event.process/1","type":"function","doc":"Process a Brook.Event struct via synchronous call to the Brook.Server"},{"ref":"Brook.Event.html#send/3","title":"Brook.Event.send/3","type":"function","doc":"Send a message to the Brook.Server synchronously, passing the term to be encoded into a Brook.Event struct, the authoring application, and the type of event. The event type must implement the String.Chars.t type."},{"ref":"Brook.Event.html#update_data/2","title":"Brook.Event.update_data/2","type":"function","doc":"Takes a Brook.Event struct and a function and updates the data value of the struct based on the outcome of applying the function to the incoming data value. Merges the resulting data value back into the struct."},{"ref":"Brook.Event.html#t:data/0","title":"Brook.Event.data/0","type":"type","doc":""},{"ref":"Brook.Event.html#t:t/0","title":"Brook.Event.t/0","type":"type","doc":""},{"ref":"Brook.Event.Deserializer.html","title":"Brook.Event.Deserializer","type":"protocol","doc":"The protocol for standard de-serialization of Elixir structs passed through the Brook event stream for decoding from the in-transit format. Brook drivers are expected to implement a default de-serializer for converting from a given encoding to an Elixir struct, leaving the client the option to implement a custom de-serializer for specific struct types."},{"ref":"Brook.Event.Deserializer.html#deserialize/2","title":"Brook.Event.Deserializer.deserialize/2","type":"function","doc":"Convert the given encoded term to an instance of the supplied struct type."},{"ref":"Brook.Event.Deserializer.html#t:reason/0","title":"Brook.Event.Deserializer.reason/0","type":"type","doc":""},{"ref":"Brook.Event.Deserializer.html#t:t/0","title":"Brook.Event.Deserializer.t/0","type":"type","doc":""},{"ref":"Brook.Event.Handler.html","title":"Brook.Event.Handler","type":"behaviour","doc":"Defines the Brook.Event.Handler behaviour that an application is expected to provide for processing events off the event stream via Brook, as well as a default implementation."},{"ref":"Brook.Event.Handler.html#__before_compile__/1","title":"Brook.Event.Handler.__before_compile__/1","type":"macro","doc":"Simple default handle_event/1 implementation that discards the message and takes no other action."},{"ref":"Brook.Event.Handler.html#__using__/1","title":"Brook.Event.Handler.__using__/1","type":"macro","doc":"A using macro to define a module as implementing the Brook.Event.Handler behaviour and supply a default implementation of the required handle_event/1 function."},{"ref":"Brook.Event.Handler.html#c:handle_event/1","title":"Brook.Event.Handler.handle_event/1","type":"callback","doc":"Process incoming events from the event stream and return a result with optional persistence of values to the application view state."},{"ref":"Brook.Event.Handler.html#t:create/0","title":"Brook.Event.Handler.create/0","type":"type","doc":"The return value of a create operation to save a value to the view state"},{"ref":"Brook.Event.Handler.html#t:delete/0","title":"Brook.Event.Handler.delete/0","type":"type","doc":"The return value of a delete operation to remove a value from the view state"},{"ref":"Brook.Event.Handler.html#t:discard/0","title":"Brook.Event.Handler.discard/0","type":"type","doc":"The return value of an event that should not persist any result to the view state."},{"ref":"Brook.Event.Handler.html#t:merge/0","title":"Brook.Event.Handler.merge/0","type":"type","doc":"The return value of merging a new value into the existing value with the view state saved under a given key and collection."},{"ref":"Brook.Event.Serializer.html","title":"Brook.Event.Serializer","type":"protocol","doc":"The protocol for standard serialization of Elixir structs to an in-transit encoding format before sending on the Brook event stream. Brook drivers are expected to implement a default serializer for converting to the given encoding, leaving the client the option to implement a custom serializer for specific struct types."},{"ref":"Brook.Event.Serializer.html#serialize/1","title":"Brook.Event.Serializer.serialize/1","type":"function","doc":"Convert the supplied Elixir term to an encoded term wrapped in an :ok tuple."},{"ref":"Brook.Event.Serializer.html#t:reason/0","title":"Brook.Event.Serializer.reason/0","type":"type","doc":""},{"ref":"Brook.Event.Serializer.html#t:t/0","title":"Brook.Event.Serializer.t/0","type":"type","doc":""},{"ref":"Brook.Event.Serializer.html#t:type/0","title":"Brook.Event.Serializer.type/0","type":"type","doc":""},{"ref":"Brook.Server.html","title":"Brook.Server","type":"module","doc":"Process event messages to and from the underlying event stream message bus implementation. Interact with the application&#39;s persisted view state of the event stream with getter and setter functions to write and update events from the view state as well as delete them."},{"ref":"Brook.Server.html#child_spec/1","title":"Brook.Server.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Server.html#get/2","title":"Brook.Server.get/2","type":"function","doc":"Return an value, stored under a given key for a given collection from the view state."},{"ref":"Brook.Server.html#get_all/1","title":"Brook.Server.get_all/1","type":"function","doc":"Return all values stored in the view state for a given collection. Values are returned as a map where the keys are the term used to store the value to the view state and the values are the data produced from event processing."},{"ref":"Brook.Server.html#get_events/2","title":"Brook.Server.get_events/2","type":"function","doc":"Returns a list of Brook events that produced the value saved under the given key within a collection from the application view state."},{"ref":"Brook.Server.html#init/1","title":"Brook.Server.init/1","type":"function","doc":"Initialize a Brook server configuration."},{"ref":"Brook.Server.html#start_link/1","title":"Brook.Server.start_link/1","type":"function","doc":"Start a Brook server and link it to the current process"},{"ref":"Brook.Storage.html","title":"Brook.Storage","type":"behaviour","doc":"Defines the Brook.Storage behaviour that must be implemented by storage driver processes. Starts a process and defines a child specification for including the driver in Brook&#39;s supervision tree. Implements the CRUD functionality for persisting events to the application view state within the storage driver and subsequent retrieval."},{"ref":"Brook.Storage.html#c:child_spec/1","title":"Brook.Storage.child_spec/1","type":"callback","doc":"Define a child specification for including the storage driver in the Brook supervision tree."},{"ref":"Brook.Storage.html#c:delete/2","title":"Brook.Storage.delete/2","type":"callback","doc":"Delete the record of a saved value from the view state within a given collection and identified by a given key."},{"ref":"Brook.Storage.html#c:get/2","title":"Brook.Storage.get/2","type":"callback","doc":"Return a value from the persisted view state stored within a collection and identified by a key."},{"ref":"Brook.Storage.html#c:get_all/1","title":"Brook.Storage.get_all/1","type":"callback","doc":"Return all values saved to the application view state within the storage system under a given collection. Events are returned as a map with the identifying keys as keys and the saved values as values."},{"ref":"Brook.Storage.html#c:get_events/2","title":"Brook.Storage.get_events/2","type":"callback","doc":"Return a list of events that produced a value saved to the application view state within the storage system under a given collection and idetifying key."},{"ref":"Brook.Storage.html#c:persist/4","title":"Brook.Storage.persist/4","type":"callback","doc":"Save a value from a processed event to the application view state stored on the underlying storage system. Events are saved to a collection of related events under a given identifying key. The event is simultaneously stored under a different key to serve as a log of all events that produced or modified the value saved to the given key and collection."},{"ref":"Brook.Storage.html#c:start_link/1","title":"Brook.Storage.start_link/1","type":"callback","doc":"Start the storage driver and link it to the current process."},{"ref":"Brook.Storage.Ets.html","title":"Brook.Storage.Ets","type":"module","doc":"Implements the Brook.Storage behaviour for ETS, saving the application view state to the in-memory Erlang key/value datastore. As ETS is in-memory, this implementation is intended for testing purposes and not recommended for production persistence of application data."},{"ref":"Brook.Storage.Ets.html#child_spec/1","title":"Brook.Storage.Ets.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Storage.Redis.html","title":"Brook.Storage.Redis","type":"module","doc":"Implements the Brook.Storage behaviour for the Redis key/value storage system, saving the application view state as binary encodings of the direct Elixir terms to be saved with maximum compression."},{"ref":"Brook.Storage.Redis.html#child_spec/1","title":"Brook.Storage.Redis.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Storage.Redis.html#t:config/0","title":"Brook.Storage.Redis.config/0","type":"type","doc":""},{"ref":"Brook.Supervisor.html","title":"Brook.Supervisor","type":"module","doc":"A Brook application supervisor, managing the process registry, storage and driver module processes, and the server process."},{"ref":"Brook.Supervisor.html#child_spec/1","title":"Brook.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Supervisor.html#init/1","title":"Brook.Supervisor.init/1","type":"function","doc":"Initialize the Brook supervisor with all necessary child processes."},{"ref":"Brook.Supervisor.html#start_link/1","title":"Brook.Supervisor.start_link/1","type":"function","doc":"Start a Brook supervisor and link it to the current process."},{"ref":"Brook.UnsupportedMerge.html","title":"Brook.UnsupportedMerge","type":"exception","doc":"An exception for handling bad merge operations when attempting to save an event to the application view state."}]